---
title: 我在看什么 · 5-8月
created: 2023-08-27
summary: 数据库 / The Power of Free Time / recycling symbol
tags: 
  - 我在看什么
---
好久不见。

## CS

- [Using HTML elements as CSS masks | Artur Bień](https://expensive.toys/blog/black-pixel-masking)
- [Python As Fast as Possible - Learn Python in ~75 Minutes](https://www.youtube.com/watch?v=VchuKL44s6E)
- [The new CSS pseudo-classes explained - :is() :where() :has()](https://www.youtube.com/watch?v=3ncFpP8GP4g)
- [:has() opens up new possibilities with CSS](https://www.youtube.com/watch?v=OGJvhpoE8b4)
- [Modern CSS in Real Life - Chris Coyier](https://chriscoyier.net/2023/06/06/modern-css-in-real-life/)
  - 非常好的一篇文章，在这篇文章里介绍了很多比较新的 CSS 特性
- [A Firefox-only minimap | Stefan Judis Web Development](https://www.stefanjudis.com/a-firefox-only-minimap/)
- [The Difference Between Web Sockets, Web Workers, and Service Workers | CSS-Tricks - CSS-Tricks](https://css-tricks.com/the-difference-between-web-sockets-web-workers-and-service-workers/)
	- Web Sockets
		- [Introducing WebSockets – Bringing Sockets to the Web](https://web.dev/websockets-basics/) (web.dev)
		- [Thinking About Power Usage and Websites](https://css-tricks.com/thinking-about-power-usage-and-websites/) (Chris Coyier)
	- Web Workers:
		- [Intro to Web Workers](https://zapier.com/engineering/intro-to-web-workers/) (Zapier)
		- [使用 Web Workers - Web API 接口参考 | MDN](https://developer.mozilla.org/zh-CN/docs/Web/API/Web_Workers_API/Using_web_workers)
	- Service Workers:
		- [Add a Service Worker to Your Site](https://css-tricks.com/add-a-service-worker-to-your-site/) (Chris Ferdinadi)
		- [Smaller HTML Payloads with Service Workers](https://philipwalton.com/articles/smaller-html-payloads-with-service-workers/) (Philip Walton)
		- [使用 Service Worker - Web API 接口参考 | MDN](https://developer.mozilla.org/zh-CN/docs/Web/API/Service_Worker_API/Using_Service_Workers)
- [Why Learn Compilers (2021) | Hacker News](https://news.ycombinator.com/item?id=36102865)
- [ES2023 introduces new array copying methods to JavaScript | Sonar](https://www.sonarsource.com/blog/es2023-new-array-copying-methods-javascript/)
- [Do Logical Properties Make CSS Easier to Learn? - Chris Coyier](https://chriscoyier.net/2023/05/02/do-logical-properties-make-css-easier-to-learn/)
- [JavaScript’s Backtick Strings are Likely the Wrong Tool for Your Job](https://spin.atomicobject.com/2023/06/05/javascript-backtick-strings-wrong/)
- [SICP in Emacs](https://kchousos.github.io/posts/sicp-in-emacs/)
- [The large, small, and dynamic viewport units](https://web.dev/viewport-units/)
- [Working with UUID in Node](https://masteringjs.io/tutorials/node/uuid)
	- 在Node.v14.17中，可以通过 `crypto.randomUUID()` 来生成UUID
- [Most Senior React Devs Don’t Know How To Fix This](https://www.youtube.com/watch?v=vXJkeZf-4-4)
- [WebGL-WebGPU-frameworks-libraries](https://gist.github.com/dmnsgn/76878ba6903cf15789b712464875cfdc)
- [【译】Shader艺术编码入门介绍(An introduction to Shader Art Coding) - Bilibili](https://www.bilibili.com/video/BV1DM4y1n7eB/)
	- 原视频： [An introduction to Shader Art Coding - YouTube](https://www.youtube.com/watch?v=f4s1h2YETNY)
	- 不算好的入门视频
- [【网络】半小时看懂「计算机网络」 哔哩哔哩\_bilibili](https://www.bilibili.com/video/BV124411k7uV/)
- SourceMap相关
  - [What are source maps? - YouTube](https://www.youtube.com/watch?v=FIYkjjFYvoI)
  - [【第876期】Source Map入门教程](https://mp.weixin.qq.com/s/spuUk-X231ZJpqzVQHHHrw)
  - [【第3020期】解读SourceMap](https://mp.weixin.qq.com/s/1AgxyTGj2gnhblQa2KAFSA)
- 数据库相关比较
  - [SQLite vs MySQL vs PostgreSQL A Comparison Of Relational Database Management Systems](https://www.digitalocean.com/community/tutorials/sqlite-vs-mysql-vs-postgresql-a-comparison-of-relational-database-management-systems)
  - [PostgreSQL vs SQLite Comparing Two Popular Databases](https://www.beekeeperstudio.io/blog/postgresql-vs-sqlite)
  - [How To Manage an SQL Database | DigitalOcean](https://www.digitalocean.com/community/tutorials/how-to-manage-sql-database-cheat-sheet)
  - [A Comparison of NoSQL Database Management Systems and Models](https://www.digitalocean.com/community/tutorials/a-comparison-of-nosql-database-management-systems-and-models)
- Vector Database 相关
  - [Vector databases are so hot right now. WTF are they? - YouTube](https://www.youtube.com/watch?v=klTvEwg3oJ4)
  - [Vector Databases simply explained! (Embeddings & Indexes) - YouTube](https://www.youtube.com/watch?v=dN0lsF2cvm4)
  - [你真的需要一个（专门的）向量数据库么 | 高策](http://gaocegege.com/Blog/vector)
    - [What is an embedding, anyways? - by Richard Demsyn-Jones](https://simplicityissota.substack.com/p/what-is-an-embedding-anyways)
    - [Enhancing ChatGPT With Infinite External Memory Using Vector Database and ChatGPT Retrieval Plugin | by Ruolin | Better Programming](https://betterprogramming.pub/enhancing-chatgpt-with-infinite-external-memory-using-vector-database-and-chatgpt-retrieval-plugin-b6f4ea16ab8)
- [We need to talk about Prisma](https://www.youtube.com/watch?v=J2j1XwZRi30)
- [菲利普·罗伯茨：到底什么是Event Loop呢？ | 欧洲 JSConf 2014](https://www.youtube.com/watch?v=8aGhZQkoFbQ)
- [Jake Archibald: 在循环 - JSConf.Asia](https://www.youtube.com/watch?v=cCOL7MC4Pl0)
- [What Is GraphQL? REST vs. GraphQL](https://www.youtube.com/watch?v=yWzKJPw_VzM)
- [You're (Probably) Using Prettier Wrong](https://www.youtube.com/watch?v=Cd-gBxzcsdA)
- [蓝绿发布、滚动发布、灰度发布（金丝雀）](https://199604.com/2548)

## 杂谈
-  [The Power of Free Time | Pearl Leff](https://www.pearlleff.com/the-power-of-free-time)
    > Here are some suggestions that enable that without impacting the bottom line:
    > -  **Part-time options**: Allow employees the option to work reduced hours, such as three or four days a week (even temporarily), and receive the commensurate proportion of their salary.
    > - **Sabbaticals**: Many companies have sabbatical programs providing employees with an extended period of time off after a certain number of years to pursue personal interests, engage in professional development, or just recharge.
    > - **Openness to unpaid leave**: Foster an environment where unpaid leave is seen as a positive measure rather than a cause for concern.
-  [Concise explanations accelerate progress — Steph Ango](https://stephanango.com/concise)
- [How To Be Successful - Sam Altman](https://blog.samaltman.com/how-to-be-successful)
- [Nat Friedman](https://nat.org/)
  > - Enthusiasm matters!
  > -  It's much easier to work on things that are exciting to you
  > - It might be easier to do big things than small things for this reason
  > - You learn more per unit time because you make contact with reality more frequently
- [Internet Search Tips · Gwern.net](https://gwern.net/search)
  > A description of advanced tips and tricks for effective Internet research of papers/books, with real-world examples.
- [Google rolls out anti-stalking measures for AirTag and other Bluetooth trackers](https://www.engadget.com/google-rolls-out-anti-stalking-measures-for-airtag-and-other-bluetooth-trackers-194936293.html)
- [You Can Achieve Anything If You Focus On ONE Thing - Darius Foroux](https://dariusforoux.com/one-thing/)
- [The best way to acquire knowledge from readings](https://medium.com/heptabase/the-best-way-to-acquire-knowledge-from-readings-abf9357814d1#717b)
  > 在這個過程中，真正有價值的並不是你最終產出的這個白板，而是你在執行第二步到第四步的過程中建立知識架構、給每張卡片和 Section 下標題所投入的思考過程。真正的理解和洞察往往源自於將知識分解、重組的這個過程。只有在走過這個過程後，這些知識才會真正變成你的知識。
- [You Might Be Using Typescript Wrong… - YouTube](https://www.youtube.com/watch?v=RmGHnYUqQ4k)
  - 提到可以用[Zod](https://zod.dev/) 做类型inference，最近试了下挺好用的，不过我以为是用在表单的，就用得比较局限。刚开始用的时候看了点这个：[Zod Makes TypeScript Even Better - YouTube](https://www.youtube.com/watch?v=9UVPk0Ulm6U)，然后就对着文档写了，最近有个替代品叫 Valibot：[Introducing Valibot](https://www.builder.io/blog/introducing-valibot)
- [How To Learn A New Programming Language](https://piped.privacydev.net/watch?v=E8cM12jRH7k)
  > 1.exploration/documentation phase  
  > 2.building a WebSocket server   
  > 3.interpreter

## 有意思
- [Could we make the web more immersive using a simple optical illusion?](https://shopify.github.io/spatial-commerce-projects/WonkaVision/)
- [why Japan’s internet is weirdly designed](https://piped.privacydev.net/watch?v=z6ep308goxQ) 
  - 虽然没有讲清楚缘由，但视频拍得挺有意思的。
  - 这个视频则补充了文化方面的因素：[How culture made Japanese Internet design “Weird”](https://youtu.be/Opy-SjDU0UY)
- [Introducing Fatebook: the fastest way to make and track predictions](https://www.lesswrong.com/posts/yS3d46m23wRKDQobt/introducing-fatebook-the-fastest-way-to-make-and-track)
- [Hacker News Blogroll](https://dm.hn/)
- [Firefox address bar.](https://wiki.tilde.institute/w/firefox-address-bar-tips)
- [Use your Phone as Keyboard and Mouse | The Most Powerful App I've seen!](https://www.youtube.com/watch?v=ljmmaZyYSxc)
- [重新认识电子表格Excel](https://www.biaodianfu.com/spreadsheets-and-excel.html)
  > 微软 Excel 的第一个版本是为苹果公司编写的。 事实上，微软是受史蒂夫乔布斯的委托，为苹果当时正在进行的一个非常秘密的项目编写一个图形界面的电子试算表: Lisa 和第一台 Macintosh，以及他们第一个个人电脑的图形用户界面。 微软为 Mac 电脑提供了 Excel，但同时也秘密开始了自己的项目。 这个项目最终变成了微软的 Windows。 乔布斯认为这是一种背叛，因此开始了乔布斯和比尔盖茨之间的竞争，直到2011年乔布斯去世，这种竞争一直没有结束。
- [BLOCKING CHATGPT FROM STEALING YOUR CONTENT](https://bored.horse/post/blocking-chatgpt-from-stealing-your-content/)
- [Vulfpeck Live at Madison Square Garden](https://www.youtube.com/watch?v=rv4wf7bzfFE)

## 工具

- [Git is simply too hard](https://changelog.com/posts/git-is-simply-too-hard)
  > But I think whatever the next iteration of the people’s version control is… it should be something that is more reflective of how we think about what version control is for us.

  > I feel that version control systems (the next version of them) should not be something that was specifically made for the Linux Kernel community. It should be something that was specifically designed to be used by the wider community.  

  我想找一个Git的替代品，了解到有一个叫 [Fossil](https://fossil-scm.org/home/doc/trunk/www/index.wiki) 的东西，最近还有一个叫 [Jujutsu](https://github.com/martinvonz/jj) 的，不过还没深入使用
- [skiff](https://skiff.com/)  
  免费的加密邮箱，功能很多，但是：[PSA: Skiff.com is lying about being open source!](https://raikas.dev/skiff-is-lying-about-being-open-source/)
- [Apprise - Push Notifications that work with just about every platform!](https://github.com/caronc/apprise)
- [Twine: A Compose multiplatform RSS reader app](https://github.com/msasikanth/twine)

## 设计
- [AI in User Experience (UX) Design: A Fresh Approach | by Dhananjay Mukerji | Aug, 2023 | UX Planet](https://uxplanet.org/ai-in-user-experience-ux-design-a-fresh-approach-c7c7956daad8)
- a11y: [Web Interface Guidelines](https://interfaces.rauno.me/)
- [Where did the recycling symbol come from? Who designed it? ](https://uxdesign.cc/where-did-the-recycling-symbol-come-from-who-designed-it-3c9584a1af6c)
  > Using the recycling symbol became a way of participating in this movement and signaling a commitment to environmental responsibility. It helped to create a sense of unity and shared purpose among diverse groups, reinforcing the collective behavior toward recycling and sustainability.


## Open Source
- [开源世界的尴尬时刻](https://mp.weixin.qq.com/s/rNXC1BaxsUgsjEWwK00sGQ)
- [2023-24: 漩涡事件反思录](https://xuanwo.io/reports/2023-24/)
- [使用Apache协议的是自由软件吗？](https://mp.weixin.qq.com/s/QUbEB2cX-I6-ugipJ-C9Rg)
- [奇特的“对自杀说不”许可证”](https://mp.weixin.qq.com/s/Bf7dPwb-T-CMbIJM0MEV2Q)
- [How to Write a Great README](https://www.appsmith.com/blog/write-a-great-readme)
- [Generating income from open source](https://vadimdemedes.com/posts/generating-income-from-open-source)

## 语言学习
- [Why I'm Quitting the Japanese Duolingo Course (An Honest Review)](https://www.youtube.com/watch?v=jf-SbSfiXn4)
- [如何学习语言：输入假说（为什么大多数方法没有效果） - YouTube](https://www.youtube.com/watch?v=J_EQDtpYSNM)
- [Learn to Read Korean in 5 Minutes (seriously)](https://www.youtube.com/watch?v=TE4eplsFSms)
- [法语学习入门补充 | Xuanqi](https://xuanqi.life/post/2022/03/29/%E6%B3%95%E8%AF%AD%E5%AD%A6%E4%B9%A0%E5%85%A5%E9%97%A8%E8%A1%A5%E5%85%85/)  
  这人的博客有很多不错的内容，虽然页面比较复古。

## 其他
还在看Yao 推荐的 [『Ground-Up Computer Science』](https://www.yinwang.org/blog-cn/2021/05/11/gucs-sample)，不过我的进展有点缓慢

以及最近开始看《半泽直树》

最后：[It's okay to not like things](https://www.youtube.com/watch?v=0la5DBtOVNI)